<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 0rem 3rem">     
      <el-row>
        <el-col :span="4" :offset="12">
          <div class="block">
            <el-date-picker
              @change="searchMovement(date, 'date')" clearable
              format="MM/yyyy"
              v-model="date"
                value-format="timestamp"
              placeholder="Escoja un mes"
              type="month"> 
            </el-date-picker>
          </div>
        </el-col>
        <el-col :span="5"  :offset="2">
          <el-input @keyup.enter.native="searchMovement(textSearch, 'numberMovement')" clearable
            placeholder="N° de movimiento"
            v-model="textSearch"
              @clear="cleanSearch">
            <i slot="prefix" class="el-input__icon el-icon-search"></i>
          </el-input>
        </el-col> 
      </el-row>
    </header>
    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 0rem 1rem">
      <Title Title="HISTORIAL DE MOVIMIENTOS "> </Title>
    </div>
    <!-- style="margin:2.5rem 7rem 3rem" -->
    <div >
      <!-- Tarjeta 'No hay resultado' -->
      <el-row v-bind:class="[ contractsMovement.length == 0 ? 'remove-grid-container' : 'grid-container' ]" v-if="isShowNoResults" >
        <el-col :span="20" :offset="2">
          <el-card :body-style="{ padding: '0px' }" class="bg-gray">
            <el-col :span="8" style="margin-top: 1rem" class="text-center">
              <img src="@/assets/images/detective.svg" alt="">
            </el-col>
            <el-col :span="16">
              <div style="margin-top: 5rem">
                <p class="title-styles">¡Lo sentimos!</p>
                <p class="title-styles">No encontramos resultados para tu búsqueda </p>
              </div>
            </el-col>
          </el-card>
        </el-col>
      </el-row>
      <div v-else>
        <el-row type="flex" justify="end">
          <!-- <el-col :span="2" :offset="20"> -->
            <!-- <el-button @click="printPage()"  type="primary"  style="margin-left: 35px" plain>
              <i style="margin-left: 5px" class="el-icon-printer"></i>IMPRIMIR
          </el-button> -->
          <el-tooltip class="item" effect="dark" content="Imprimir" placement="bottom">
						<el-button @click="printPage" class="margin_l_35 btn_icons_p font-size-25" icon="icon-print" type="iconGrid"></el-button>
					</el-tooltip>
          <!-- </el-col> -->
        </el-row>
        <el-row v-for="(mat, index) in contractsMovement" :key="index" >
          <el-col :span="24" class="box-historial" style="padding: 70px 50px 30px; margin-top: 5rem">
            <el-row style="margin-bottom: 2rem">
              <el-col :span="6" :offset="18">
                 <span class="text-orange text-bold fonts-bold-general text-bold"> N° DE MOVIMIENTO: </span>
                 <span class="text-bold text-orange" style="padding-left:15px">  {{  mat.movementNumber }} </span>
              </el-col>
            </el-row>
            <el-row style="margin-bottom: 1rem" >
              <el-col :span="11">
                <el-row >
                  <el-col :span="24" class="row-info-rev">
                    <span class="fonts-bold-general text-bold"> Proveedor: </span>
                    <span > {{  mat.contractName }} </span>
                  
                  </el-col>
                  <el-col :span="24" class="row-info-rev">
                    <span class="fonts-bold-general text-bold"> Cod Proveedor:</span>
                    <span >  {{  mat.providerCode }} </span>
                  </el-col>
                </el-row>
              </el-col>
              <el-col :span="7">
                <div >
                  <el-col :span="24" class="row-info-rev">
                    <span class="fonts-bold-general text-bold"> Cod. Registro: </span>
                    <span>  {{  mat.contractCode }} </span>
                  </el-col>
                  <el-col :span="24" class="row-info-rev">
                    <span class="fonts-bold-general text-bold">N° Contr. Distribuidor:</span>
                    <span> {{ mat.contratoDistribuidor }} </span>
                  </el-col>
                </div>
              </el-col>
              <el-col :span="6">
                <div >
                  <el-col :span="24" class="row-info-rev">
                    <span class="fonts-bold-general text-bold"> Fecha: </span>
                    <span > {{  new Date(mat.registrationDate).toLocaleDateString('en-GB') }} </span>
                  </el-col>
                </div>
              </el-col>
            </el-row>
            <el-table style="margin-top: 2.5rem" class="tableMovement"
              :header-cell-class-name="tableRowClassName"
              border
              :data="mat.materialsRegistration">
              <el-table-column
                prop="codMaterial"
                label="Cod. Material">
              </el-table-column>
              <el-table-column
                :label="'Titúlo Orginal'">
                <template slot-scope="scope">
                  <p>{{scope.row.refMaterials.originalTitle}}</p>
                </template>
              </el-table-column>

              <el-table-column
                label="Titúlo">
                <template slot-scope="scope">
                  <p>{{scope.row.refMaterials.listTitle}}</p>
                </template>
              </el-table-column>

              <el-table-column
                label="Posición en el contrato">
                <template slot-scope="scope">
                  <p>{{ scope.row.refMaterials.contractPosition }}</p>
                </template>
              </el-table-column>

              <el-table-column 
                prop="typeOfContent"
                label="Tipo de Cont.">
              </el-table-column>
               <el-table-column 
                width="80"
                prop="numberCap"
                label="N° Cap." >
                <template slot-scope="scope">
                  <p>{{ scope.row.numberCap }}</p>
                </template>
              </el-table-column>

              <el-table-column
                width="100"
                label="Soporte de llegada" >
                <template slot-scope="scope">
                  <p>{{ arrivalSupportInfo(scope.row.refMaterials, scope.row.numberCap, mat.materialsRegistration) }}</p>
                </template>
              </el-table-column>

              <el-table-column
                width="100"
                prop="numberCap"
                label="Modo de Envío">
                <template slot-scope="scope">
                  <p>{{ shippingModeInfo(scope.row.refMaterials,  scope.row.numberCap) }}</p>
                </template>
              </el-table-column>
              <el-table-column
                width="100"
                prop="guideNumber"
                label="Número de Guía">
                 <template slot-scope="scope">
                  <p>{{ guideNumberInfo(scope.row.refMaterials, scope.row.numberCap) }}</p>
                </template>
              </el-table-column>

               <el-table-column
                width="80"
                prop="currencySymbol"
                label="Moneda" >
              </el-table-column>
                <el-table-column 
                label="Valor Capítulo">
                <template slot-scope="scope">
                  <p>{{ getFormat(scope.row.unitPrice) }}</p>
                </template>
              </el-table-column> 
            </el-table>
            <el-row style="margin:2rem 0 1rem">
              <el-col :span="6" :offset="1" class=" text-bold"> <p> N° DE CAPITULOS: <span> <span style="padding-left:1rem">  </span> {{ mat.materialsRegistration.length }} </span></p></el-col>
              <el-col :span="7" :offset="10" class=" text-bold"> <p>IMPORTE TOTAL: <span> <span style="padding-left:1rem">  </span>  {{mat.currencySymbol}}  {{ getFormat(getSumPriceTotal(mat.materialsRegistration) )}} </span></p></el-col>
            </el-row>
          </el-col>
        </el-row> 
        <el-row style="margin:5rem 0; font-size: 18px" class="text-orange text-bold">
          <el-col :span="6" :offset="2" > <p> TOTAL DE CAPITULOS: <span style="margin-left: 15px"> {{ totalCap }} </span></p></el-col>
          <el-col :span="7" :offset="8" > <p> TOTAL GENERAL: <span style="margin-left: 15px">{{calculateTotal(contractsMovement, totalGeneral)}}</span></p></el-col>
        </el-row>

      </div>
    </div>
  </div>
</template>

<script>

import Title from '@/components/Title.vue'
import { convertNumberFormatUsd, convertDate } from '@/utils/calculateTime.js'
import { HTTP } from '@/main.js'


export default {
  components: {
    Title,
  },
  data() {
    return {
      textSearch: '',
      date: '',
      IsClick: false,
      isShowNoResults: false,
    }
  },
  methods: {
    calculateTotal(contractsMovement, totalGeneral) {
      let result = []
      if(contractsMovement && contractsMovement.length > 0) {
        let {currencySymbol} = contractsMovement[0]
        result.push(currencySymbol)
      }
      if(totalGeneral) {
        result.push(totalGeneral)
      }
      return result.join(' ')
    },
    printPage () {
      if (this.IsClick) {
        this.$localStorage.set('filterPrint', 'filterNumberMovement')
      }
      else {
        this.$localStorage.set('filterPrint', 'limitMovementTenRegisters')
      }
      this.$router.push({name: 'printMovement'})
    },
    cleanSearch () {
      this.IsClick = false
    },
    searchMovement (textSearch, type ) {
      console.log({textSearch, type}, 'searchMovement')
      if (textSearch != null ) {
        let params = { textSearch: textSearch, type: type }        
        this.$store.commit('SEARCH_MOVEMENT', params )
        this.IsClick = true
      }
      else {
        this.IsClick = false
      }
    },
    getSumPriceTotal (array) {
      let priceTotal = 0
      let newArr = array.filter((el) => el.unitPrice != 'Cortesía')
      newArr.map((el, i ) => {
        priceTotal += el.unitPrice
      })
      return priceTotal
    },
    tableRowClassName ({row, rowIndex}) {
      if (rowIndex === 0) {
        return 'bg-light-red';
      }
    },
    getFormat (valor) {
      if (valor != 'Cortesía') {
        return convertNumberFormatUsd(valor)
      }
      else {
        return valor
      }
    },
    arrivalSupportInfo(data, mat, info) {
      const {numChapters, movementData, infoSupport} = data
      if(numChapters.length > 0) {
        let chap = movementData.length > 0 ? movementData[0].filter((e) => e.chapter == mat) : []
        return chap[0] && chap[0].arrivalSupport !== '' ? chap[0].arrivalSupport : ''
      } else {
        // return movementData[0] && movementData[0].arrivalDate  !== '' ? convertDate(movementData[0].arrivalDate) : ''
        return movementData[0] && movementData[0].arrivalSupport  !== '' ? movementData[0].arrivalSupport : ''
      }
    },
    shippingModeInfo(data, mat) {
      const {numChapters, movementData, infoSupport} = data

      if(numChapters.length > 0) {
        let chap = movementData.length > 0 ? movementData[0].filter((e) => Number(e.chapter) == Number(mat)) : []
        return chap[0] && chap[0].shippingMode !== '' ? chap[0].shippingMode : ''
      } else {
        return movementData[0] && movementData[0].shippingMode  !== '' ? movementData[0].shippingMode : ''
      }
    },
    guideNumberInfo(data, mat) {
      let {numChapters, movementData, infoSupport} = data
      if(numChapters.length > 0) {
        let chap = movementData.length > 0 ? movementData[0].filter((e) => Number(e.chapter) == Number(mat)) : []
        return chap[0] && chap[0].guideNumber !== '' ? chap[0].guideNumber : ''
      } else {
        return movementData[0] && movementData[0].guideNumber  !== '' ? movementData[0].guideNumber : ''
      }
    },
  },
  computed: {
    contractsMovement () {
      try {
        let a
        if(this.IsClick) {
         a = this.$store.getters.filterNumberMovement
         this.isShowNoResults = a.length == 0  ? true : false
        }
        else {
         a =  this.$store.getters.limitMovementTenRegisters 
         this.IsClick = false
         this.isShowNoResults = a.length == 0  ? true : false
        }
        console.log(a)
        return a
      } catch (e) {
        console.log(e)
      }
    },
    totalGeneral () {
      let total = 0
      if (this.contractsMovement.length > 0) {
         this.contractsMovement.map((el, i, arr) => {
           el.materialsRegistration.map((ella) => {
            total +=  ella.unitPrice == "Cortesía" ? 0 : Number(ella.unitPrice)
           })
         })
      }
      return this.getFormat(total)
    },
    totalCap () {
      let total = 0
      if (this.contractsMovement.length > 0) {
        this.contractsMovement.map((el, i, arr) => {
        total +=  el.materialsRegistration.length
        })
      }
      return total
    }
  }
}
</script>
<style lang="css">
  .tableMovement .cell {
    word-break: break-word !important;
  }
</style>